/* -*-Prolog-*-
	(Currently the comments are written in Japanese EUC.)

	    ̿CTL+multiagent BDI logic
	     ǽȽ&ץ v1.01

  Ȥ:
    ?- prove().		ľǽȽ
    ?- prove_treedisp().	ľǽʾϾڤɽ
		ڤηɽΤǤϤʤκΥ٥
		ƥǥȤɽ

  Ȥƽ񤱤ΤӤܥץǤɽ

					|ܥץǤɽ
	--------------------------------+----------------------
	true, false			|true, false
	̿			|Prologatom
	բ˦, բʦ, ̦		|\/, /\, ~
	բ, բΦ			|=>, <=>
	AX , AF , AG 		|ax , af , ag 
	EX , EF , EG 		|ex , ef , eg 
	A( U ), E( U )		| au ,  eu 
	BEL a , DESIRE a ,		|
	  INTEND a 			|a bel , a des , a int 
	G-BEL g , G-DESIRE a ,	|
	  G-INTEND a 			|g gbel , g gdes , g gint 
	E-BEL g , E-DESIRE a ,	|
	  E-INTEND a 			|g ebel , g edes , g eint 
	M-BEL g , M-DESIRE a ,	|
	  M-INTEND a 			|g mbel , g mdes , g mint 

	( aϥȤɽPrologatom
	 gϥȷɽPrologatomΥꥹȡ,פ)

  ʳˡʲάɲä

		     ά  		|    	 |    
			| ܥץ	|		 |
	  Ȥ	|   Ǥɽ	|		 |
	----------------+---------------+----------------+----------------
	pBEL a 	|a pbel 	|BEL a̦	 |possibly BEL
	pDESIRE a 	|a pdes 	|DESIRE a̦	 |
	pINTEND	a 	|a pint 	|INTEND a̦	 |
	A( W )	| aw 	|E(բʢ̦ U  |
			|		|     ̦բʢ̦)|weak until
	E( W )	| ew 	|E( U )EG|
	A( N )	| an 	|A(̦ U բʦ)|atnext
	E( N )	| en 	|E(̦ U բʦ)|
	A( WN )	| awn 	|A(̦ W բʦ)|weak atnext
	E( WN )	| ewn 	|E(̦ W բʦ)|

  ̤ͥϰʲ̤(ۤ˷)
    ñ४ڥ졼, Ū֥ڥ졼(belʤ), /\, \/,
    ꥪڥ졼(au,euʤ), =>, <=>
	beldes/\\/衢aueu/\\/˷礹뤳Ȥ

 : ?- prove(a int af p au a bel p => a int af p au a bel p \/ ~(a bel ef p)).
   A(INTEND a(AF p)U BEL(p)) A(INTEND a(AF p)U (BEL(p)ˢBEL a(EF p)))ξ
   (Ǹ夬~a bel ef pȡ~bel˷礷~aȤȤ
    ˤʤäưʤ)

  SWI-PrologǤưϳǧѤ B-Prolog, SICStus PrologϤ줫
  âB-Prolog, SICStus PrologǤϡΰβսuncommentɬפ

						by nide@ics.nara-wu.ac.jp
*/

/* append, member, select, intersection, unionɬ */

/* on B-Prolog, activate this */
/*
intersection(A, B, C) :- intersect(A, B, C).
between(X, Y, _) :- X > Y, !, fail.
between(X, _, X).
between(X, Y, Z) :- X1 is X+1, between(X1, Y, Z).
*/

/* on SICStus-Prolog, activate this */
/*
append([], L, L).
append([A|L], M, [A|N]) :- append(L, M, N).
member(A, [A|_]).
member(A, [_|L]) :- member(A, L).
select(A, [A|L], L).
select(A, [B|L], [B|M]) :- select(A, L, M).
intersection([], _, []) :- !.
intersection([A|L], M, [A|N]) :- member(A, M), !, intersection(L, M, N).
intersection([_|L], M, N) :- intersection(L, M, N).
union([], L, L).
union([A|L], M, N) :- member(A, M), !, union(L, M, N).
union([A|L], M, [A|N]) :- union(L, M, N).
between(X, Y, _) :- X > Y, !, fail.
between(X, _, X).
between(X, Y, Z) :- X1 is X+1, between(X1, Y, Z).
*/ /* It is no more necessary to define \= on SICStus */
 /* B-/SICStus-PrologǤνսꤳˤ⤦1սꤢ */

:- /* ڥ졼ν */
	op(550, xfx, <=>), op(540, xfy, =>),
	op(530, yfx, au), op(530, yfx, eu), op(530, yfx, aw), op(530, yfx, ew),
	op(530, yfx, an), op(530, yfx, en),
	op(530, yfx, awn), op(530, yfx, ewn),
 /* /\פ' 'פȡProlog󥿥ץ꥿ˤäơ'/\'פȽ񤫤ͤ
    ʤʤä'/\\'פȽ񤫤ͤФʤʤäꤹ */
	op(520, yfx, \/), op(510, yfx, /\), op(500, fy, '~'),
	op(500, fy, ax), op(500, fy, ag), op(500, fy, af),
	op(500, fy, ex), op(500, fy, eg), op(500, fy, ef),
	op(505, xfy, bel), op(505, xfy, des), op(505, xfy, int),
	op(505, xfy, desire), op(505, xfy, intend),
	op(505, xfy, pbel), op(505, xfy, pdes), op(505, xfy, pint),
	op(505, xfy, ebel), op(505, xfy, edes), op(505, xfy, eint),
	op(505, xfy, gbel), op(505, xfy, gdes), op(505, xfy, gint),
	op(505, xfy, mbel), op(505, xfy, mdes), op(505, xfy, mint),
	true.

 /* exp_ab(+F, -G)FάŸΤGâϽ
    \/, ~, ax, au, eu, bel, des, int, gbel, gdes, gintʳΥڥ졼
    true, falseάgbel, gdes, gintΥȷsort */
	/* ʲprimitives */
exp_ab(P, P) :- atom(P), P \= true, P \= false, !.
	/* PrologatomΤtrue, false2Ĥ̰ */
exp_ab(F \/ G, F1 \/ G1) :- exp_ab(F, F1), exp_ab(G, G1).
exp_ab(~F, F1) :- exp_ab(F, NF1),
	(NF1 = ~F1; F1 = ~NF1), !. /* Ͻ褦ˤ */
exp_ab(ax F, ax F1) :- exp_ab(F, F1).
exp_ab(F au G, F1 au G1) :- exp_ab(F, F1), exp_ab(G, G1).
exp_ab(F eu G, F1 eu G1) :- exp_ab(F, F1), exp_ab(G, G1).
exp_ab(Ag bel F, Ag bel F1) :- atom_chk(Ag), exp_ab(F, F1).
exp_ab(Ag des F, Ag des F1) :- atom_chk(Ag), exp_ab(F, F1).
exp_ab(Ag int F, Ag int F1) :- atom_chk(Ag), exp_ab(F, F1).
exp_ab(L gbel F, L1 gbel F1) :- sort(L, L1), atomlist_chk(L1), exp_ab(F, F1).
exp_ab(L gdes F, L1 gdes F1) :- sort(L, L1), atomlist_chk(L1), exp_ab(F, F1).
exp_ab(L gint F, L1 gint F1) :- sort(L, L1), atomlist_chk(L1), exp_ab(F, F1).
	/* ʲabbreviations */
exp_ab(true, '_' \/ ~'_') :- !.
exp_ab(false, F1) :- exp_ab(~true, F1), !.
exp_ab(F /\ G, F1) :- exp_ab(~(~F \/ ~G), F1).
exp_ab(F => G, F1) :- exp_ab(~F \/ G, F1).
exp_ab(F <=> G, F1) :- exp_ab((F => G) /\ (G => F), F1).
exp_ab(ex F, F1) :- exp_ab(~ax~F, F1).
exp_ab(af F, F1) :- exp_ab(true au F, F1).
exp_ab(ef F, F1) :- exp_ab(true eu F, F1).
exp_ab(ag F, F1) :- exp_ab(~ef~F, F1).
exp_ab(eg F, F1) :- exp_ab(~af~F, F1).
exp_ab([Ag|L] ebel F, F1) :- exp_ab((Ag bel F) /\ (L ebel F), F1). 
exp_ab([Ag] ebel F, F1) :- exp_ab(Ag bel F, F1).
exp_ab([Ag|L] edes F, F1) :- exp_ab((Ag des F) /\ (L edes F), F1). 
exp_ab([Ag] edes F, F1) :- exp_ab(Ag des F, F1).
exp_ab([Ag|L] eint F, F1) :- exp_ab((Ag int F) /\ (L eint F), F1). 
exp_ab([Ag] eint F, F1) :- exp_ab(Ag int F, F1).
exp_ab(L mbel F, F1) :- exp_ab(L ebel (L gbel F), F1).
exp_ab(L mdes F, F1) :- exp_ab(L edes (L gdes F), F1).
exp_ab(L mint F, F1) :- exp_ab(L eint (L gint F), F1).
	/* ɲäabbreviations */
exp_ab(F aw G, F1) :- exp_ab(~(F/\ ~G eu ~F/\ ~G), F1).
exp_ab(F ew G, F1) :- exp_ab((F eu G) \/ eg F, F1).
exp_ab(F an G, F1) :- exp_ab(~G au F/\G, F1).
exp_ab(F en G, F1) :- exp_ab(~G eu F/\G, F1).
exp_ab(F awn G, F1) :- exp_ab(~G aw F/\G, F1).
exp_ab(F ewn G, F1) :- exp_ab(~G ew F/\G, F1).
exp_ab(Ag pbel F, F1) :- exp_ab(~(Ag bel~F), F1).
exp_ab(Ag pdes F, F1) :- exp_ab(~(Ag des~F), F1).
exp_ab(Ag pint F, F1) :- exp_ab(~(Ag int~F), F1).
	/* 褯Ȥɽ */
exp_ab(Ag desire F, F1) :- exp_ab(Ag des F, F1).
exp_ab(Ag intend F, F1) :- exp_ab(Ag int F, F1).
 /* exp_ab_list(+L, -L1)ΥꥹLγǤ򤽤줾άŸ
	ꥹȤL1deterministic */
exp_ab_list([F|L], [F1|L1]) :-
 	exp_ab(F, F1), exp_ab_list(L, L1), !.
exp_ab_list([], []).

atom_chk(A) :- atom(A) -> true; write(A), write(': atom expected'), nl, fail.
atomlist_chk([A|L]) :- atom_chk(A), atomlist_chk(L).
atomlist_chk([]).

 /* classify(-A1, -O1, +F, +A, +O)ΥꥹFǤ̿
	ȥåץ٥Υڥ졼ax, bel, des, intʤΤȡʳ
	ʬԤA˸ԤOappendΤA1O1deterministic */
classify1([F|Atomic_new], Other_new, [F|New], Atomic, Other) :-
	(atom(F); F = ax _; F = _ bel _; F = _ des _; F = _ int _),
	classify1(Atomic_new, Other_new, New, Atomic, Other), !.
classify1(Atomic_new, [F|Other_new], [F|New], Atomic, Other) :-
	classify1(Atomic_new, Other_new, New, Atomic, Other), !.
classify1(Atomic, Other, [], Atomic, Other).
classify(A1, O1, F, A, O) :- classify1(A2, O2, F, A, O),
	sort(A2, A1), sort(O2, O1), !.
 /* sort褦ˤʤäʤsequentμ¸sort
    Ĥ褦ˤ褤Ϥ(̤) */

 /* sel_ax_lr(-LF, -RFX, +LA, +RA)ΥꥹLAΤȥåץ٥뤬ax
	ΤᡢΥȥåץ٥axΤLFΥꥹRA
	ȥåץ٥뤬axΤι⡹1ĤӡΥȥåץ٥ax
	ΤΥꥹȤRFX(Ĺ⡹1)LFsort롣LF, RFXΤ줫
	RFX;Ϥ뤿deterministicǤϤʤ */
 /* sel_des_lr, sel_int_lrsel_axƱͤDES-KDINT-KDŬѤ
	Ȥˤ;Ϥ */
 /* sel_bel_lr(-LF, -RF1, -LB, -RB, +LA, +RA)sel_ax˻뤬Υꥹ
	LAΤȥåץ٥뤬bel a(aΥ)ΤΤ᤿
	ΤLBΥȥåץ٥belΤLFΥꥹRAΤ
	ȥåץ٥뤬bel aΤΤ᤿ΤRBΤ1Ĥ
	Υȥåץ٥belΤΥꥹȤRF1(Ĺ⡹1) */
sel_ax_lr(LF, RFX, LA, RA) :-
	sel_ax_list(LF, LA), sel_ax_list(RF, RA), !,
	(RF = [] -> LF \= [], RFX = [], !; member(RF1, RF), RFX = [RF1]).
sel_ax_list(As, A) :-
	sel_ax_select(A, Ab), sort(Ab, As), !. /* deterministic */
sel_ax_select([ax G|A], [G|Ab]) :- !, sel_ax_select(A, Ab).
sel_ax_select([_|A], Ab) :- !, sel_ax_select(A, Ab).
sel_ax_select([], []).
sel_bel_lr(Ag, LF, RF1, LB, RB, LA, RA) :-
	sel_bel_list(LAs, LA), sel_bel_list(RAs, RA), !,
	sel_agt(Ag, LF, RF, RF1, LAs, RAs), /* no cut */
	sel_bel_add(Ag, LF, LB), sel_bel_add(Ag, RF, RB).
sel_bel_list(Bs, A) :- sel_bel_select(A, Ab), sort(Ab, Abs),
	sel_agt_split(Abs, Bs), !. /* deterministic */
sel_bel_select([Ag bel G|A], [(Ag, G)|Ab]) :- !, sel_bel_select(A, Ab).
sel_bel_select([_|A], Ab) :- !, sel_bel_select(A, Ab).
sel_bel_select([], []).
sel_bel_add(Ag, [G|F], [Ag bel G|B]) :- !, sel_bel_add(Ag, F, B).
sel_bel_add(_, [], []).
sel_des_lr(LF, RF1, LA, RA) :-
	sel_des_list(LAs, LA), sel_des_list(RAs, RA), !,
	sel_agt(_, LF, _, RF1, LAs, RAs). /* no cut */
sel_des_list(Bs, A) :- sel_des_select(A, Ab), sort(Ab, Abs),
	sel_agt_split(Abs, Bs), !. /* deterministic */
sel_des_select([Ag des G|A], [(Ag, G)|Ab]) :- !, sel_des_select(A, Ab).
sel_des_select([_|A], Ab) :- !, sel_des_select(A, Ab).
sel_des_select([], []).
sel_int_lr(LF, RF1, LA, RA) :-
	sel_int_list(LAs, LA), sel_int_list(RAs, RA), !,
	sel_agt(_, LF, _, RF1, LAs, RAs). /* no cut */
sel_int_list(Bs, A) :- sel_int_select(A, Ab), sort(Ab, Abs),
	sel_agt_split(Abs, Bs), !. /* deterministic */
sel_int_select([Ag int G|A], [(Ag, G)|Ab]) :- !, sel_int_select(A, Ab).
sel_int_select([_|A], Ab) :- !, sel_int_select(A, Ab).
sel_int_select([], []).
sel_agt_split([(Ag, G), (Ag, H)|B], [(Ag, [G|A])|As]) :- !,
	sel_agt_split([(Ag, H)|B], [(Ag, A)|As]).
sel_agt_split([(Ag, G)|B], [(Ag, [G])|As]) :- !, sel_agt_split(B, As).
sel_agt_split([], []).
sel_agt(Ag, LF, RF, RFX, LA, RA) :- sel_agt_aux(Ag, LF, RF, LA, RA),
	(RF = [] -> RFX = []; member(RF1, RF), RFX = [RF1]). /* no cut */
sel_agt_aux(Ag, LF, RF, [(Ag1, LF1)|LA], [(Ag1, RF1)|RA]) :- !,
	(Ag = Ag1, LF = LF1, RF = RF1; sel_agt_aux(Ag, LF, RF, LA, RA)).
sel_agt_aux(Ag, LF, RF, [(Ag1, LF1)|LA], RA) :-
	(RA = [(Ag2, _)|_] -> Ag1 @< Ag2; true /* RA=[] */), !, 
	(Ag = Ag1, LF = LF1, RF = []; sel_agt_aux(Ag, LF, RF, LA, RA)).
sel_agt_aux(Ag, LF, RF, LA, [(Ag2, RF1)|RA]) :- !,
	(Ag = Ag2, LF = [], RF = RF1; sel_agt_aux(Ag, LF, RF, LA, RA)).

 /* sequentɽ: seq(Hash, left(AtomicL, OtherL), right(AtomicR, OtherR))
      left, rightsequentΡ֢פκ
      AtomicL/R: ̿ax, bel, des, intȥåץ٥˻Υꥹ
      OtherL/R: ʳΥꥹ
      Hash: sequenthash γhashƤXOR(ä
	sequentνؤäƤƱ) seq_eq/2Ƚ˻Ȥ
	âSWI-PrologѻΤ
 */

 /* seq_eq(+S1, +S2)sequent S1S2 */
seq_eq(seq(Hash, left(LA, LO), right(RA, RO)),
       seq(Hash, left(LA1,LO1), right(RA1,RO1))) :-
	multiset_eq(LA, LA1), multiset_eq(LO, LO1),
	multiset_eq(RA, RA1), multiset_eq(RO, RO1), !.
multiset_eq([E|L], L1) :- select(E, L1, L2), multiset_eq(L, L2), !.
multiset_eq([], []).
 /* seq_member(?S, +L)sequent SsequentΥꥹL¸ */
seq_member(S, [Seq|_]) :- seq_eq(S, Seq).
seq_member(S, [_|SeqList]) :- seq_member(S, SeqList).
 /* on SICStus-Prolog or B-Prolog, activate this and comment out
    the next three clauses */
/*
make_seq(seq(_, left(LA, LO), right(RA, RO)), left(LA, LO), right(RA, RO)):-!.
*/
make_seq(seq(H, left(LA, LO), right(RA, RO)), left(LA, LO), right(RA, RO)) :-
	calc_hash(LA, H1), calc_hash(LO, H2),
	calc_hash(RA, H3), calc_hash(RO, H4), H is H1 xor H2 xor H3 xor H4.
calc_hash([T|L], H) :- calc_hash(L, H1), hash_term(T, H2), H is H1 xor H2, !.
calc_hash([], 0).

 /* ΡɤǤloopδ: loopinfo(PosTerm, PosUnterm, Neg)
	PosTerm: դ鸫ƤޤǤ˴˽λ롼פγơФ
		Υ롼פAU/EU-󱦤ʬƤ뤳ȤΤ
		setͤ 롼פǤintersection
		ä 롼פޤʤuniversal_set
	PosUnterm: դ鸫ƤޤλƤʤ롼פΡդsequent
		Υ롼פAU/EU-󱦤ʬƤ뤳ȤΤ
		setΥڥ 롼פˤĤƥꥹȤˤ
		[(Seq1, EvSet1), (Seq2, EvSet2), ]
		Seq1, Seq2Ĥsequent EvSet1, EvSet2, ĤϽset
		դƱsequentʣΥ롼פ1ĤˤޤȤΤ
		(setintersection)
		Seq1, Seq2ĤˤϽʣϤʤ
	Neg: 롼פAU/EU-󺸤ʬƤ뤳ȤΤ
		set

	롼פʤǾǤƤΡɤǤloopinfo(universal_set, [], [])
	ʤ ʳΥΡɤǤPosUnterm[]ˤʤʤ
 */

 /* PosTermintersection universal_setʤ¾򤽤Τޤ֤ */
my_intersection(universal_set, L2, L2) :- !.
my_intersection(L1, universal_set, L1) :- !.
my_intersection(L1, L2, L) :- intersection(L1, L2, L), !.
 /* select_unterm((+Seq, -EvSet), +PosUnterm, -PosUnterm1)
	PosUntermˡդSeqȤ롼פФνset
	EvSetñ첽ĤPosUnterm1 */
select_unterm((Seq, EvSet), [(Seq1, EvSet)|PosUnterm], PosUnterm) :-
	seq_eq(Seq, Seq1), !.
select_unterm(SeqEvPair, [SeqEvPair1|PosUnterm], [SeqEvPair1|PosUnterm1]) :-
	select_unterm(SeqEvPair, PosUnterm, PosUnterm1).
 /* append_unterm(+PosUnterm1, +PosUnterm2, -PosUnterm)
	PosUnterm12ξͻ礷PosUnterm */
append_unterm([(Seq,EvSet1)|PosUnterm1],PosUnterm2, [(Seq,EvSet)|PosUnterm]) :-
	select_unterm((Seq, EvSet2), PosUnterm2, PosUnterm2rest),
	intersection(EvSet1, EvSet2, EvSet),
	append_unterm(PosUnterm1, PosUnterm2rest, PosUnterm), !.
append_unterm([SeqEvPair|PosUnterm1], PosUnterm2, [SeqEvPair|PosUnterm]) :-
	append_unterm(PosUnterm1, PosUnterm2, PosUnterm), !.
append_unterm([], PosUnterm, PosUnterm).

 /* loopinfochk_eventual(+Loopinfo1, +Loopinfo2, +Seq, +Ev, -Loopinfo)
	SeqΡ֢פ˸F au GF eu GηEvФ
	AU/EU-ŬѤƤΡɤ 󺸤Υ롼״Loopinfo1
	󱦤Υ롼״Loopinfo2Ȥ
	ΥΡɤΥ롼״Loopinfo˵ */
loopinfochk_eventual(loopinfo(PosTerm1, PosUnterm1, Neg1),
		     loopinfo(PosTerm2, PosUnterm2, Neg2), Seq, Ev,
		     loopinfo(PosTerm, PosUnterm, Neg)) :-
	(PosUnterm1 = [] -> Neg1new = Neg1; union(Neg1, [Ev], Neg1new)),
	loopinfoevadd(PosUnterm2, Ev, PosUnterm2new),
	loopinfo2chk(loopinfo(PosTerm1, PosUnterm1, Neg1new),
		     loopinfo(PosTerm2, PosUnterm2new, Neg2), Seq,
		     loopinfo(PosTerm, PosUnterm, Neg)), !.
 /* loopinfoevadd(+PosUnterm, +Ev, -PosUnterm1)
	PosUnterm˵ϿƤƥ롼פνEvɲä
	ΤPosUnterm1 */
loopinfoevadd([(Seq, EvSet)|PosUnterm], Ev, [(Seq, EvSet1)|PosUnterm1]) :-
	union(EvSet, [Ev], EvSet1),
	loopinfoevadd(PosUnterm, Ev, PosUnterm1), !.
loopinfoevadd([], _, []).
 /* loopinfochk(+Loopinfo, +Seq, ?LoopinfoNew)
	LoopinfoΤΥΡɤǽλ롼פξPosUntermPosTerm
	ܤ 뿷ʥ롼׾LoopinfoNew
	â ⤷ΥΡɤ롼פλƤ
	Ǥ뤿ξå(ƤʤФǼ)
	LoopinfoNewloopinfo(universal_set,[],[])ˤ */
loopinfochk(loopinfo(PosTerm, PosUnterm, Neg), Seq, LoopinfoNew) :-
	select_unterm((Seq, EvSet), PosUnterm, PosUnterm1),
	my_intersection(EvSet, PosTerm, PosTerm1),
	 /* now PosTerm1 \= universal_set */
	(PosUnterm1 = [] -> !,
			member(Ev, PosTerm1), \+member(Ev, Neg),
			LoopinfoNew = loopinfo(universal_set, [], []);
		LoopinfoNew = loopinfo(PosTerm1, PosUnterm1, Neg)), !.
loopinfochk(Loopinfo, _, Loopinfo).
loopinfo2chk(Loopinfo1, Loopinfo2, Seq, LoopinfoNew) :-
	loopinfounite(Loopinfo1, Loopinfo2, Loopinfo),
	loopinfochk(Loopinfo, Seq, LoopinfoNew), !.
loopinfounite(loopinfo(PosTerm1, PosUnterm1, Neg1),
	      loopinfo(PosTerm2, PosUnterm2, Neg2),
	      loopinfo(PosTerm, PosUnterm, Neg)) :-
	my_intersection(PosTerm1, PosTerm2, PosTerm),
	append_unterm(PosUnterm1, PosUnterm2, PosUnterm),
	union(Neg1, Neg2, Neg), !.
loopinfoLunite([Loopinfo1|LoopinfoL], Loopinfo) :-
	loopinfoLunite(LoopinfoL, Loopinfo1, Loopinfo).
loopinfoLunite([Loopinfo1|LoopinfoL], Loopinfo2, Loopinfo) :- !,
	loopinfounite(Loopinfo1, Loopinfo2, Loopinfo3),
	loopinfoLunite(LoopinfoL, Loopinfo3, Loopinfo).
loopinfoLunite([], Loopinfo, Loopinfo).

prove(F, T) :- prove_seq([], [F], T).
 /* prove_seq(+L, +R, ?T)sequent LRǤ뤫åT̤
	Ƥ˸¤ꡢT˾ڤ֤Ǥʤоڤ֤ʤΤ
	åˤʤ */
prove_seq(L, R, T) :- init_prove_status,
	exp_ab_list(L, L1), exp_ab_list(R, R1),
	classify(LA, LO, L1, [], []), classify(RA, RO, R1, [], []),
	make_seq(S, left(LA, LO), right(RA, RO)), !,
	prove_seq_trace([S], loopinfo(_, [], _), T), clear_prove_status.
prove(F) :- prove_seq([], [F]).
prove_seq(L, R) :- prove_seq(L, R, notree).
prove_treedisp(F) :- prove_seq_treedisp([], [F]).
prove_seq_treedisp(L, R) :- prove_seq(L, R, T), disp_tree(T).

assert_first(X) :-
	assert(X), functor(X, F, N), abolish(F/N), assert(X), !.
	 /* SICStus complains when trying to abolish undefined predicate */
:- dynamic provable_status/2, proving_status/1.
init_prove_status :-
	assert_first(provable_status([], [])),
	assert_first(proving_status([])), !.
clear_prove_status :-
	abolish(provable_status/2), abolish(proving_status/1).

 /* ڤɽ */
disp_tree(T) :- disp_tree(T, 0).
disp_tree([C|AL], N) :-
	tab(N), seq_write(C), nl, N1 is N+1, !, disp_trees(AL, N1).
disp_trees([], _).
disp_trees([A|AL], N) :- disp_tree(A, N), !, disp_trees(AL, N).
seq_write(seq(_, left(LA, LO), right(RA, RO))) :-
	append(LA, LO, L), append(RA, RO, R),
	list_write(L), (L = [] -> true; write(' ')),
	write('->'),
	(R = [] -> true; write(' ')), list_write(R), !.
list_write([]) :- !.
list_write([X]) :- write(X), !.
list_write([X|L]) :- write(X), write(', '), list_write(L).

/* prove_seq_trace(X, _, _) :- write('try: '), write(X), nl, fail. */

 /* initial seq. */
prove_seq_trace([S|_], loopinfo(universal_set, [], []), T) :-
	S = seq(_, left(LA, LO), right(RA, RO)),
	((member(F, LA), member(F, RA)); (member(F, LO), member(F, RO))),
	(var(T) -> T = [S]; true), !.
 /* loop */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	seq_member(S, Rest), !,
	 /* 롼פǾǽʤΤϽ˸¤ */
	S = seq(_, left(LA, LO), right(RA, RO)),
	(member(_ au _, LO); member(ax(_ au _), LA);
	 member(_ eu _, LO); member(~ ax ~(_ eu _), LO);
	 member(ax ~(_ eu _), RA); member(~(_ eu _), RO);
	 member(_ gbel _, RO); member(Ag bel(AgL gbel _), RA), member(Ag, AgL);
	 member(_ gdes _, RO); member(Ag des(AgL gdes _), RA), member(Ag, AgL);
	 member(_ gint _, RO); member(Ag int(AgL gint _), RA), member(Ag, AgL)
	),!,
	Loopinfo = loopinfo(universal_set, [(S, [])], []),
	(var(T) -> T = [S]; true), !.
	/* fails if PosUnterm is already bound to [] */

 /* ~-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [~F|LO]), right(RA, RO)),
	classify(RA_new, RO_new, [F], RA, RO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA, LO), right(RA_new, RO_new)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, LO), right(RA, [~F|RO])),
	classify(LA_new, LO_new, [F], LA, LO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA_new, LO_new), right(RA, RO)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* \/-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, ['_'\/ ~'_'|LO]), R),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA, LO), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
	 /* : κtrueϢ˺ʬ򤻤WeakǾõ
	    ԤäƤⴰξˤϱƶͿ
	    äƾǽȽꥢ르ꥺݤ
	    νɲäȡag Fʤɤ򢪤κդ˻sequentξ
	    ۤȤƱޤ2󸡾ڤʤƺѤߡΨ夬ǽ */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [F\/G|LO]), R),
	classify(LA_new1, LO_new1, [F], LA, LO),
	classify(LA_new2, LO_new2, [G], LA, LO),
	(var(T) -> true; TL = T, TR = T), !,
	make_seq(S1, left(LA_new1, LO_new1), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	make_seq(S2, left(LA_new2, LO_new2), R),
	prove_seq_trace([S2, S|Rest], Loopinfo2, TR),
	loopinfo2chk(Loopinfo1, Loopinfo2, S, Loopinfo),
	(var(T) -> T = [S, TL, TR]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [F\/G|RO])),
	classify(RA_new, RO_new, [F, G], RA, RO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, L, right(RA_new, RO_new)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* au-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [F au G|LO]), R),
	classify(LA_new1, LO_new1, [G], LA, LO),
	classify(LA_new2, LO_new2, [F, ax(F au G)], LA, LO),
	(var(T) -> true; TL = T, TR = T), !,
	make_seq(S1, left(LA_new1, LO_new1), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	make_seq(S2, left(LA_new2, LO_new2), R),
 	prove_seq_trace([S2, S|Rest], Loopinfo2, TR),
	loopinfochk_eventual(Loopinfo1, Loopinfo2, S, F au G, Loopinfo),
	(var(T) -> T = [S, TL, TR]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [F au G|RO])),
	classify(RA_new1, RO_new1, [F, G], RA, RO),
	classify(RA_new2, RO_new2, [G, ax(F au G)], RA, RO),
	(var(T) -> true; TL = T, TR = T), !,
	make_seq(S1, L, right(RA_new1, RO_new1)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	make_seq(S2, L, right(RA_new2, RO_new2)),
	prove_seq_trace([S2, S|Rest], Loopinfo2, TR),
	loopinfo2chk(Loopinfo1, Loopinfo2, S, Loopinfo),
	(var(T) -> T = [S, TL, TR]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* eu-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [F eu G|LO]), R),
	classify(LA_new1, LO_new1, [G], LA, LO),
	classify(LA_new2, LO_new2, [F, ~ax~(F eu G)], LA, LO),
	(var(T) -> true; TL = T, TR = T), !,
	make_seq(S1, left(LA_new1, LO_new1), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	make_seq(S2, left(LA_new2, LO_new2), R),
	prove_seq_trace([S2, S|Rest], Loopinfo2, TR),
	loopinfochk_eventual(Loopinfo1, Loopinfo2, S, F eu G, Loopinfo),
	(var(T) -> T = [S, TL, TR]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [F eu G|RO])),
	classify(RA_new1, RO_new1, [F, G], RA, RO),
	classify(RA_new2, RO_new2, [G, ~ax~(F eu G)], RA, RO),
	(var(T) -> true; TL = T, TR = T), !,
	make_seq(S1, L, right(RA_new1, RO_new1)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	make_seq(S2, L, right(RA_new2, RO_new2)),
	prove_seq_trace([S2, S|Rest], Loopinfo2, TR),
	loopinfo2chk(Loopinfo1, Loopinfo2, S, Loopinfo),
	(var(T) -> T = [S, TL, TR]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* gbel-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [AgL gbel F|LO]), R),
	setof(Ag bel (AgL gbel F), member(Ag, AgL), Fs),
	classify(LA_new, LO_new, [F|Fs], LA, LO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA_new, LO_new), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [AgL gbel F|RO])),
	classify(RA_new, RO_new, [F], RA, RO),
	(var(T) -> true; TL = T), !,
	make_seq(S1, L, right(RA_new, RO_new)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	prove_seq_gaux(AgL, bel, AgL gbel F, L, RA, RO, [S|Rest], T,
		LoopinfoL, TRL),
	loopinfoLunite(LoopinfoL, Loopinfo2),
	loopinfochk_eventual(Loopinfo1, Loopinfo2, S, AgL gbel F, Loopinfo),
	(var(T) -> T = [S, TL|TRL]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* gdes-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [AgL gdes F|LO]), R),
	setof(Ag des (AgL gdes F), member(Ag, AgL), Fs),
	classify(LA_new, LO_new, [F|Fs], LA, LO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA_new, LO_new), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [AgL gdes F|RO])),
	classify(RA_new, RO_new, [F], RA, RO),
	(var(T) -> true; TL = T), !,
	make_seq(S1, L, right(RA_new, RO_new)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	prove_seq_gaux(AgL, des, AgL gdes F, L, RA, RO, [S|Rest], T,
		LoopinfoL, TRL),
	loopinfoLunite(LoopinfoL, Loopinfo2),
	loopinfochk_eventual(Loopinfo1, Loopinfo2, S, AgL gdes F, Loopinfo),
	(var(T) -> T = [S, TL|TRL]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* gint-L/R */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, [AgL gint F|LO]), R),
	setof(Ag int (AgL gint F), member(Ag, AgL), Fs),
	classify(LA_new, LO_new, [F|Fs], LA, LO),
	(var(T) -> true; T1 = T), !,
	make_seq(S1, left(LA_new, LO_new), R),
	prove_seq_trace([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, L, right(RA, [AgL gint F|RO])),
	classify(RA_new, RO_new, [F], RA, RO),
	(var(T) -> true; TL = T), !,
	make_seq(S1, L, right(RA_new, RO_new)),
	prove_seq_trace([S1, S|Rest], Loopinfo1, TL),
	prove_seq_gaux(AgL, int, AgL gint F, L, RA, RO, [S|Rest], T,
		LoopinfoL, TRL),
	loopinfoLunite(LoopinfoL, Loopinfo2),
	loopinfochk_eventual(Loopinfo1, Loopinfo2, S, AgL gint F, Loopinfo),
	(var(T) -> T = [S, TL|TRL]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* ax-KD with Weak */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, []), right(RA, [])),
	sel_ax_lr(LA_axoff, RA_axoff, LA, RA), /* no cut */
	 /* at least either LA_axoff or RA_axoff is not empty */
	classify(LA_new, LO_new, LA_axoff, [], []),
	classify(RA_new, RO_new, RA_axoff, [], []), /* no cut */
	(var(T) -> true; T1 = T), /* no cut */
	make_seq(S1, left(LA_new, LO_new), right(RA_new, RO_new)),
	prove_seq_trace_modal([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* bel-KD45 with Weak */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, []), right(RA, [])),
	sel_bel_lr(Ag, LA_beloff, RA_beloff, LA_belonly, RA_belonly, LA, RA),
	classify(LA_new, LO_new, LA_beloff, LA_belonly, []),
	classify(RA_new, RO_new, RA_beloff, RA_belonly, []),
	\+bel_incl_in_other(Ag, LA_new, LO_new, RA_new, RO_new, LA, RA),
	(var(T) -> true; T1 = T),
	make_seq(S1, left(LA_new, LO_new), right(RA_new, RO_new)),
	prove_seq_trace_modal([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* des-KD with Weak */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, []), right(RA, [])),
	sel_des_lr(LA_desoff, RA_desoff, LA, RA),
	classify(LA_new, LO_new, LA_desoff, [], []),
	classify(RA_new, RO_new, RA_desoff, [], []),
	(var(T) -> true; T1 = T),
	make_seq(S1, left(LA_new, LO_new), right(RA_new, RO_new)),
	prove_seq_trace_modal([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
 /* int-KD with Weak */
prove_seq_trace([S|Rest], Loopinfo, T) :-
	S = seq(_, left(LA, []), right(RA, [])),
	sel_int_lr(LA_intoff, RA_intoff, LA, RA),
	classify(LA_new, LO_new, LA_intoff, [], []),
	classify(RA_new, RO_new, RA_intoff, [], []),
	(var(T) -> true; T1 = T),
	make_seq(S1, left(LA_new, LO_new), right(RA_new, RO_new)),	
	prove_seq_trace_modal([S1, S|Rest], Loopinfo1, T1),
	loopinfochk(Loopinfo1, S, Loopinfo),
	(var(T) -> T = [S, T1]; true),
	(Loopinfo = loopinfo(_, [], _) -> !; true).
prove_seq_gaux([Ag|AgL], Modal, F, L, RA, RO, SL, T,
	       [Loopinfo1|LoopinfoL], TLL) :-
	!, (var(T) -> TLL = [T1|TL]; T1 = T),
	R1 =.. [Modal, Ag, F], sort([R1|RA], RA_new),/* instead of classify */
	make_seq(S, L, right(RA_new, RO)), !,
	prove_seq_trace([S|SL], Loopinfo1, T1), /* no cut */
	prove_seq_gaux(AgL, Modal, F, L, RA, RO, SL, T, LoopinfoL, TL).
prove_seq_gaux([], _,_, _,_,_, _,_, [], []).

 /* ꥪڥ졼򳰤ľsequentˤĤƤϡǤ/Ǥʤä
    ˤΤȤϿƤ */
prove_seq_trace_modal([S|_], loopinfo(universal_set, [], []), T) :-
	provable_status(S, provable), !,
	(var(T) -> T = [S]; true), !. /* omit duplicated tree */
prove_seq_trace_modal([S|_], _, _) :-
	provable_status(S, non_provable), !, fail.
prove_seq_trace_modal(SL, L, T):-
	gensym('_', A), prove_seq_trace_modal(A, SL, L, T).

prove_seq_trace_modal(A, [S|Rest], Loopinfo, T) :-
	prove_seq_trace([S|Rest], Loopinfo, T),
	(Loopinfo = loopinfo(_, [], _) ->
		set_provable_status(S, A, provable), !;
		set_proving_status(S, A)).
prove_seq_trace_modal(A, [S|_], _, _) :- /* must fail */
	((proving_status(A); provable_status(S, _)) -> clear_proving_status(A);
		set_provable_status(S, A, non_provable)), !, fail.

set_provable_status(S, A, Stat) :-
	retract(provable_status(S, _)), fail;
	assert(provable_status(S, Stat)), clear_proving_status(A), !.
clear_proving_status(A) :-
	retract(proving_status(A)), fail; !.
set_proving_status(S, A) :-
	((proving_status(A); provable_status(S, _)) -> true;
		assert(proving_status(A))), !.

 /* BDIڥ졼򳰤롼ǡagentФ롼ŬѤǤǤsequent
    ¾agentФŬѤǤǤΤ˴ޤޤƤޤ硢Ŭѽ
    ʬޤޤΨ褯ʤޤˤޤBelФƤŬѤƤʤ */
bdi_incl_aux([], _, _).
bdi_incl_aux([X|L], OA, O) :- member(X, OA), !, bdi_incl_aux(L, OA, O).
bdi_incl_aux([Ag bel G gbel X|L], OA, O) :-
	member(Ag, G), !, member(G gbel X, O), !, bdi_incl_aux(L, OA, O).
bdi_incl_aux([Ag des G gdes X|L], OA, O) :-
	member(Ag, G), !, member(G gdes X, O), !, bdi_incl_aux(L, OA, O).
bdi_incl_aux([Ag int G gint X|L], OA, O) :-
	member(Ag, G), !, member(G gint X, O), !, bdi_incl_aux(L, OA, O).
bel_incl_in_other(Ag, LA_new, LO_new, RA_new, RO_new, LA, RA) :-
	sel_bel_lr(Ag1, OLA_beloff,ORA_beloff, OLA_belonly,ORA_belonly, LA,RA),
	Ag1 \= Ag,
	classify(OLA_new, OLO_new, OLA_beloff, OLA_belonly, []),
	classify(ORA_new, ORO_new, ORA_beloff, ORA_belonly, []),
	subset(LO_new, OLO_new), subset(RO_new, ORO_new),
	 /* classifyLO_newOLO_new¾򥽡ȤƤ뤳Ȥ */
	bdi_incl_aux(LA_new, OLA_new, OLO_new),
	bdi_incl_aux(RA_new, ORA_new, ORO_new),
	(
		Ag1 @< Ag;
		LO_new \= OLO_new; RO_new \= ORO_new;
		\+bdi_incl_aux(OLA_new, LA_new, LO_new);
		\+bdi_incl_aux(ORA_new, RA_new, RO_new)
	), !.

/* for debug */
test_debug :- test_debug1, test_debug2, test_debug3, test_debug4, test_debug5.
test_debug1 :- loopinfochk(loopinfo([p3,q1,r1],[
		(seq(_, left([a2],[b2]),right([c2    ],[d2])),[p2,q2,r2]),
		(seq(_, left([a1],[b1]),right([cc1,c1],[d1])),[p1,q1,r1])
	],[q1]),seq(_, left([a1],[b1]),right([c1,cc2],[d1])),X),!,
	X=loopinfo([p3,q1,r1],[
		(seq(_, left([a2],[b2]),right([c2    ],[d2])),[p2,q2,r2]),
		(seq(_, left([a1],[b1]),right([cc1,c1],[d1])),[p1,q1,r1])
	],[q1]).
test_debug2 :- loopinfochk(loopinfo([p3,q1,r1],[
		(seq(_, left([a2],[b2]),right([c2    ],[d2])),[p2,q2,r2]),
		(seq(_, left([a1],[b1]),right([cc1,c1],[d1])),[p1,q1,r1])
	],[q1]),seq(_, left([a1],[b1]),right([c1,cc1],[d1])),X),!,
	X=loopinfo([q1,r1],[
		(seq(_, left([a2],[b2]),right([c2],[d2])),[p2,q2,r2])
	], [q1]).
test_debug3 :- loopinfochk(loopinfo([p3,q1,r1],[
		(seq(_, left([a1],[b1]),right([cc1,c1],[d1])),[p1,q1,r1])
	],[q1]),seq(_, left([a1],[b1]),right([c1,cc1],[d1])),X),!,
	X=loopinfo(universal_set, [], []).
test_debug4 :- \+ loopinfochk(loopinfo([p3,q1,r3],[
		(seq(_, left([a1],[b1]),right([cc1,c1],[d1])),[p1,q1,r1])
	],[q1]),seq(_, left([a1],[b1]),right([c1,cc1],[d1])),_), !.
test_debug5 :- loopinfoevadd([(a,[a1,a2]),(b,[b1,b2])],a2,X),!,
	X=[(a,[a1,a2]),(b,[b1,b2,a2])].

 /* for test */
testx1  :- prove(af q /\ ag p => p au q).
testx2  :- prove(ef q /\ ag p => p eu q).
testx3  :- prove(af q /\ eg p => p eu q).
testx4  :- prove(p /\ ag(p=>ax p) => ag p).
testx5  :- prove(p /\ ag(p=>ex p) => eg p).
testx6  :- prove(p au q => p \/ s au q \/ r).
testx7  :- prove(p eu q => p \/ s eu q \/ r).
testx8  :- \+ prove(af p \/ ef p \/ ag p \/ eg p).
testx9  :- \+ prove(ag p => p au q).
testx10 :- \+ prove(eg p => p eu q).
testx11 :- \+ prove(p => a1 bel p), \+ prove(a1 bel p => p).
testx12 :- \+ prove(ax(a1 bel p) => a1 bel ax p),
	   \+ prove(a1 bel ax p => ax(a1 bel p)).
testxe  :- prove(a1 int af p au a1 bel p =>
		 a1 int af p au (a1 bel p \/ ~(a1 bel ef p))).
testxf  :- \+ prove((p au q) /\ (r au s) =>
		af(~ax(p au q)\/ ~ax(r au s)\/(q/\s)\/(p/\r))).
testx :- testx1, testx2, testx3, testx4, testx5, testx6, testx7,
	 testx8, testx9, testx10, testx11, testx12, testxe, testxf.

test2  :- prove(ef p <=> true eu p).
test2b :- prove(ag p <=> ~ef~p).
test3  :- prove(af p <=> true au p).
test3b :- prove(eg p <=> ~af~p).
test4  :- prove(ex(p \/ q) <=> ex p \/ ex q).
test5  :- prove(ax p <=> ~ex~p).
test6  :- prove(p eu q <=> q \/ p /\ ex(p eu q)).
test7  :- prove(p au q <=> q \/ p /\ ax(p au q)).
test8  :- prove(ex true /\ ax true).
test9  :- prove(ag(r => (~q /\ (p => ex r))) => (r => ~(p au q))).
test9b :- prove(ag(r => (~q /\ ex r)) => (r => ~af q)).
test10 :- prove(ag(r => (~q /\ (p => ax r))) => (r => ~(p eu q))).
test10b:- prove(ag(r => (~q /\ ax r)) => (r => ~ef q)).
test11 :- prove(ag(p => q) => (ex p => ex q)).
test12 :- prove(ag true).
testb1 :- prove(a1 bel p /\ a1 bel (p=>q) => a1 bel q), prove(~(a1 bel ~true)).
testb2 :- prove(a1 bel p => a1 bel a1 bel p).
testb3 :- prove(~(a1 bel ~p) => a1 bel ~(a1 bel ~p)).
testb4 :- \+ prove(a1 bel p => a1 bel q).
testb5 :- prove([a1,a2] ebel (p/\q) => a2 bel q).
testb6 :- prove([a1,a2] mbel (p/\q) => [a1,a2] ebel q).
testb7 :- prove([a1,a2] gbel (p/\q) => [a1,a2] mbel q).
testb8 :- prove([a1,a2,a3] gbel (p/\q) => [a1,a3] gbel q /\ a3 bel q).
testd1 :- prove(a1 des p /\ a1 des (p=>q) => a1 des q), prove(~(a1 des ~true)).
testd2 :- prove([a1,a2,a3] gdes (p/\q) => [a1,a3] gdes q /\ a3 des q).
testi1 :- prove(a1 int p /\ a1 int (p=>q) => a1 int q), prove(~(a1 int ~true)).
testi2 :- prove([a1,a2,a3] gint (p/\q) => [a1,a3] gint q /\ a3 int q).
test0 :- test2, test2b, test3, test3b, test4, test5, test6, test7, !,
	 test8, test9, test9b, test10, test10b, test11, test12, !,
	 testb1, testb2, testb3, testb4, testb5, testb6, testb7, testb8, !,
	 testd1, testd2, testi1, testi2.

testl0 :- prove(p /\ ag((p=>ax (a1 int q au q))/\(q=>ax(a1 int p au p)))
		=> ag af p).
testl1:- X1 = ([i1,i2] mbel p),
  P1 = (~(i1 bel p)/\ ((i1 int p /\ (i1 bel p => (i1 int X1) au X1)) au X1) /\
        ~(i2 bel p)/\ ((i2 int p /\ (i2 bel p => (i2 int X1) au X1)) au X1)),
  prove(P1 => (i1 int p au i2 bel p)).
make_gamma_list_aux(F) :-
	between(1,4,I),between(1,4,J),I \= J,
	name(I,IN), name(c,CN), append(CN, IN, CIN), name(CI, CIN),
	name(J,JN), name(m,MN), append(MN, JN, MJN), name(MJ, MJN),
	exp_ab(CI bel ~MJ <=> ~MJ, F).
make_gammap_list_aux(F) :-
	between(1,4,I),between(1,4,J),I \= J,
	name(I,IN), name(c,CN), append(CN, IN, CIN), name(CI, CIN),
	name(J,JN), name(m,MN), append(MN, JN, MJN), name(MJ, MJN),
	exp_ab(CI bel MJ <=> MJ, F).
make_gammal_list_aux(F) :-
	between(1,3,I),I1 is I+1,between(I1,4,J),
	name(I,IN), name(c,CN), append(CN, IN, CIN), name(CI, CIN),
	name(J,JN), name(m,MN), append(MN, JN, MJN), name(MJ, MJN),
	exp_ab(CI bel MJ <=> MJ, F).
list2and([X,Y|L], X/\F) :- !, list2and([Y|L], F).
list2and([X], X).
testl2:- Gr = [c1,c2,c3,c4], P = Gr mbel (m1\/m2\/m3\/m4),
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S3 = Gr mbel ~(c3 bel m3),
	setof(Gr mbel F, make_gamma_list_aux(F), GL), list2and(GL, G),
	prove(P /\ G /\ S1 /\ S2 /\ S3 => c4 bel m4). /* basic case */
testl2l:- Gr = [c1,c2,c3,c4], P = Gr mbel (m1\/m2\/m3\/m4),
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S3 = Gr mbel ~(c3 bel m3),
	setof(Gr mbel F, make_gammal_list_aux(F), GL), list2and(GL, G),
	prove(P /\ G /\ S1 /\ S2 /\ S3 => c4 bel m4).
	 /* c_i can see c_j iff i<j */
testl2a:- Gr = [c1,c2,c3,c4], P = Gr mbel (m1\/m2\/m3\/m4),
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S3 = Gr mbel ~(c3 bel m3),
	setof(Gr mbel F, make_gamma_list_aux(F), GL), list2and(GL, G),
	\+prove(P /\ G /\ S1 /\ S2 /\ S3 => m4). /* m4 insted of (c4 bel m4) */
testl2g:- Gr = [c1,c2,c3,c4], P = Gr mbel (m1\/m2\/m3\/m4),
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S3 = Gr mbel ~(c3 bel m3),
	setof(Gr gbel F, make_gamma_list_aux(F), GL), list2and(GL, G),
	prove(P /\ G /\ S1 /\ S2 /\ S3 => m4).
	 /* gbel insted of mbel, m4 insted of (c4 bel m4) */
testl2n:- Gr = [c1,c2,c3,c4], P = Gr gbel (m1\/m2\/m3\/m4),
	M = m1 /\ m2 /\ m3 /\ m4,
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S_1 = Gr mbel ~(c1 bel ~m1), S_2 = Gr mbel ~(c2 bel ~m2),
	setof(Gr mbel F, make_gamma_list_aux(F), GL), list2and(GL, G),
	setof(Gr mbel F, make_gammap_list_aux(F), GL1), list2and(GL1, G1),
	\+prove(M /\ P /\ G /\ G1 /\ S1 /\ S2 /\ S_1 /\ S_2
						=> c3 bel m3 \/ c3 bel ~m3).
	 /* (n-1)st child case */
testl2t:- Gr = [c1,c2,c3,c4], P = ag(Gr mbel (m1\/m2\/m3\/m4)),
	S1 = Gr mbel ~(c1 bel m1), S2 = Gr mbel ~(c2 bel m2),
	S3 = Gr mbel ~(c3 bel m3),
	setof(ag(Gr mbel F), make_gamma_list_aux(F), GL), list2and(GL, G),
	prove(ag P /\ G /\ af(ag S1/\ af(ag S2/\ af ag S3)) => af(c4 bel m4)).
	 /* temporal version */
testl :- /* previously needed 8M global stack to try this (not now) */
	testl0, write('testl0 ok'), nl, !,
	testl1, write('testl1 ok'), nl, !,
	testl2, write('testl2 ok'), nl, !,
	testl2t, write('testl2t ok'), nl, !,
	testl2n, write('testl2n ok'), nl, !,
	testl2a, write('testl2a ok'), nl, !,
	testl2g, write('testl2g ok'), nl, !,
	testl2l, write('testl2l ok'), nl, !.

testdb :- Gr = [c1,c2], prove(Gr gbel p => Gr gbel Gr gbel (p\/q)).
testdb3 :- Gr = [c1,c2,c3], prove(Gr gbel p => Gr gbel Gr gbel (p\/q)).
testdb4 :- Gr = [c1,c2,c3,c4], prove(Gr gbel p => Gr gbel Gr gbel (p\/q)).

for(X) :- X > 0.
for(X) :- X > 1, X1 is X - 1, for(X1).
testtime :- for(100), testtime1, write(a), fail; nl.
testtime1 :- testxe, !.
/*  (echo '[bdi2].';echo 'testtime.') | time prolog ȤƻȤ
   SWIΤ褦time/1 ?- time(testtime). ȤƤȤ */
